package com.realnet.basicp1.Services;
import com.realnet.basicp1.Repository.TestbRepository;
import com.realnet.basicp1.Entity.Testb
;import java.util.*;

import org.springframework.beans.factory.annotation.Autowired;
import com.realnet.SequenceGenerator.Service.SequenceService;
import org.springframework.data.domain.Page;
import com.realnet.realm.Entity.Realm;
import com.realnet.realm.Services.RealmService;
import org.springframework.data.domain.Pageable;
import org.springframework.http.*;
import com.realnet.users.service1.AppUserServiceImpl;
import com.realnet.users.entity1.AppUser;






import com.realnet.basicp1.Entity.Testlist;
import com.realnet.basicp1.Services.TestlistService;





import com.realnet.basicp1.Entity.Testlist;
import com.realnet.basicp1.Services.TestlistService;





import com.realnet.basicp1.Entity.Testb;

import com.realnet.basicp1.Repository.TestbRepository;






	import org.springframework.stereotype.Service;

@Service
 public class TestbService {
@Autowired
private TestbRepository Repository;
	@Autowired
	private AppUserServiceImpl userService; 
@Autowired
	private RealmService realmService;





@Autowired
	private TestlistService selectdynamicserv;



@Autowired
	private TestlistService selectautocomserv;









public Testb Savedata(Testb data) {







 
if (data.getSelectdynamic() != null) {
		try {	
  int selectdynamicId = Integer.valueOf(data.getSelectdynamic());
Testlist get =  selectdynamicserv.getdetailsbyId(selectdynamicId);
			if (get != null) {

			data.setSelectdynamicname(get.getName());
}
} catch (NumberFormatException e) {
				System.out.println(" selectdynamicId is not integer..");
				// Invalid integer string — ignore or log
			}

		}

 





 
if (data.getSelectautocom() != null) {
		try {	
  int selectautocomId = Integer.valueOf(data.getSelectautocom());
Testlist get =  selectautocomserv.getdetailsbyId(selectautocomId);
			if (get != null) {

			data.setSelectautocomname(get.getName());
}
} catch (NumberFormatException e) {
				System.out.println(" selectautocomId is not integer..");
				// Invalid integer string — ignore or log
			}

		}

 










	data.setUpdatedBy(getUser().getUserId());
		data.setCreatedBy(getUser().getUserId());
		data.setAccountId(getUser().getAccount().getAccount_id());
Testb save = Repository.save(data);
				return save;	
			}


//	get all with pagination
	public Page<Testb> getAllWithPagination(Pageable page) {
		return Repository.findAll(page, getUser().getUserId());
	}			
public List<Testb> getdetails() {  
		List<Realm> realm = realmService.findByUserId(getUser().getUserId());
List<Testb> all = Repository.findAll(getUser().getUserId());
		
		return all ;		}


public Testb getdetailsbyId(Integer id) {
	return Repository.findById(id).get();
			}


	public void delete_by_id(Integer id) {
 Repository.deleteById(id);
}


public Testb update(Testb data,Integer id) {
	Testb old = Repository.findById(id).get();
old.setName(data.getName());

old.setSelectstatic(data.getSelectstatic());

old.setSelectstaticmul(data.getSelectstaticmul());

old.setSelectdynamic(data.getSelectdynamic());

old.setSelectdynamicmul(data.getSelectdynamicmul());

old.setSelectautocom(data.getSelectautocom());

old.setSelectautomul(data.getSelectautomul());



old.setChild(data.getChild());



final Testb test = Repository.save(old);
		data.setUpdatedBy(getUser().getUserId());
  return test;} 















//	Insert Action

	@Autowired
	private TestbRepository testbinsertrepository;

public Testb insertTestb(Testb data) {

data.setUpdatedBy(getUser().getUserId());
		data.setCreatedBy(getUser().getUserId());
		data.setAccountId(getUser().getAccount().getAccount_id());


		final Testb save = testbinsertrepository.save(data);
		return save;
	}





 public AppUser getUser() {
		AppUser user = userService.getLoggedInUser();
		return user;

	}}
